from donnees import creation_grille
#from outils_console import *
from outils_pygame import *
from gestion_score import charge, enregistre
from random import randint, choice

# récupération du high score
nom, best_score = charge()
message('joueur', "Best : " + nom + " - " + str(best_score) + " pts")

# début de la partie interactive
nom = saisie_nom()
grille_ordi = creation_grille()

# Création grille
#grille_joueur = place_bateaux()
grille_joueur = creation_grille()

# initialisation

data = {'ordi' : {'grille' : grille_ordi,
                  'score' : 0,
                  'coup' : 20,
                  'combo' : -1,
                  'nom' : 'R2D2'},
        'joueur' : {'grille' : grille_joueur,
                  'score' : 0,
                  'coup' : 20,
                  'combo' : -1,
                  'nom' : "K'p'tain " + nom}
        }
# pour l'AI

def recherche_de_voisins_pas_joues(grille, ligne, col):
    liste = []
    if ligne < 9 and grille[ligne + 1][col] < 10:
        liste.append((ligne + 1, col))
    if ligne > 0 and grille[ligne - 1][col] < 10:
        liste.append((ligne - 1, col))
    if col < 9 and grille[ligne][col + 1] < 10:
        liste.append((ligne, col + 1))
    if col > 0 and grille[ligne][col - 1] < 10:
        liste.append((ligne, col - 1))
    return liste


def voisins_de_touches(grille):
    liste_v = []
    for ligne in range(10):
        for colonne in range(10):
            if 12 <= grille[ligne][colonne] <= 16: # touché
                for (x, y) in recherche_de_voisins_pas_joues(grille, ligne, colonne):
                    liste_v.append((x, y))
    return liste_v

def verif_coule(grille, code_bateau):
    for ligne in range(10):
        for colonne in range(10):
            if grille[ligne][colonne] == code_bateau:
                return False
    return True

def met_a_jour(grille, cible):
    for ligne in range(10):
        for colonne in range(10):
            if grille[ligne][colonne] == cible:
                grille[ligne][colonne] += 10

def un_coup(tour):
    grille = data[tour]['grille']
    combo = data[tour]['combo']
    coup = data[tour]['coup']
    score = data[tour]['score']
    nom = data[tour]['nom']
    
    affichage(decalage, grille)
    if tour == 'joueur':
        x, y = saisie_coup(grille)
    else : # aléatoire si ordi pour l'instant
        liste_voisins = voisins_de_touches(grille)
        if len(liste_voisins) == 0: # si pas de coup proche
            x, y = randint(0, 9), randint(0, 9) # au pif
        else :
            (x, y) = choice(liste_voisins)
    code_bateau = grille[y][x]
    if 1 < grille[y][x] < 7:
        combo += 1
        score += (8 - code_bateau) + combo * 2
        message(tour, "Touché !, Bien joué " + nom)
        grille[y][x] += 10
        if verif_coule(grille, code_bateau):
            message(tour, nom + ", coulé !")
            met_a_jour(grille, code_bateau + 10)
    elif grille[y][x] == 0: # correction de bug
        combo = -1
        coup -= 1
        message(tour, "Nan " + nom + " ! (" + str(coup) + " coup(s) !)")
        grille[y][x] += 10
    affichage(decalage, grille)
    affiche_score(decalage, nom, score)
    return grille, combo, coup, score

# le jeu
tour = 'joueur' # qui commence
decalage = 0 # ou 440 pour l'ordi

while data['joueur']['coup'] > 0 or data['ordi']['coup'] > 0:
    if data[tour]['coup'] > 0:
        g, k, c, s = un_coup(tour)
        data[tour]['grille'] = g
        data[tour]['combo'] = k
        data[tour]['coup'] = c
        data[tour]['score'] = s
    if tour == 'joueur':
        tour = 'ordi'
        decalage = 440
    else :
        tour = 'joueur'
        decalage = 0


score = data['joueur']['score'] - data['ordi']['score']

if score > best_score :
    message(tour, "New High Score")
    message(tour, "K'p'tain " + nom)
    message(tour, str(score) + " points")
    enregistre(nom, score)

fin()
